/*  inp.c for ngv_save.win  */
/*   Aug. 23 1998   Rick    */

#include    <corlib.h>

extern WindowID	cwp;
char	filename[92]= "\0",
	*format[]= { "ppm", "glm", "jpg", "pic", "pi", "mag" },
	*mformat[]= { "c", "inc", "cut", "cutw", "ttl" },
	**curformat,
	vswork[20];
int defform;

extern int	shtcopy( Sheet*, Sheet* );
extern int	gvcopy( UGraphic*, UGraphic* );
extern void	saveope( void*, char*, int );
extern void	closeope( WindowID, void* );
int	popupmenu( WindowID, EventInfo* );
int	inpexec( WindowID, EventInfo* );
int	inpopen( EventInfo* );


int
popupmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	int	num, px, py, max;

	max= (curformat == format)? 6:5;
	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y;
	num= PopUpMenu( px-1, py, curformat, max, 12 );
	if( num < 0 || num >= max )	return FALSE;
	defform= num;
	WindowRedraw( wp );
	return	TRUE;
}

int
inpexec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[60], *dp=dbuf;
	static	InputClass	input;
	
	switch( info->option ){
	case EventOpen:
		InputSet( &input, 10, 30, filename, 40, 9, 12 );
		*filename= '\0';
		WindowRedraw( wp );
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON );
		cwp= wp;
		return	TRUE;
	case EventClose:
		closeope( wp, (void*)vswork );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetLine( dp++,   5,  3,  43, 23, ShadowDown, OptionShadow );
		DrawSetLine( dp++,  68, 52, 107, 67, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 148, 52, 187, 67, ShadowUp, OptionShadow );
		DrawSetLine( dp++,   8, 28, 251, 43, ShadowDown, OptionShadow );
		DrawSetSymbol( dp++,   8,  4, curformat[defform],   13, 16 );
		DrawSetSymbol( dp++,  48,  5, "format save", AttrDefault, 16 );
		DrawSetSymbol( dp++,  70, 54, " Save ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 150, 54, "Cancel", AttrDefault, 12 );
		dp+= InputSetDraw( dp, &input );
		WindowDraw( wp, dbuf, dp-dbuf );
		return	TRUE;
	case EventKey:
		if( info->KeyCode == '\r' ){
			DrawSetSymbol( dp,  48,  5, "Now saving..", AttrDefault, 16 );
			WindowDraw( wp, dbuf, 1 );
			saveope( (void*)vswork, filename, defform );
			closeope( wp, (void*)vswork );
		}else if( info->KeyCode == '\x1b' ){
			closeope( wp, (void*)vswork );
		}else {
			WindowDraw( wp, dbuf, InputKey( dbuf, &input,
						info->KeyCode, info->ShiftStat ) );
		}
		return TRUE;
	case EventMouseSwitch:
		if( info->LeftON ){
			if( info->y >52 && info->y < 67 ){
				if( info->x > 68 && info->x < 107 ){
					DrawSetSymbol( dp,  48,  5, "Now saving..", AttrDefault, 16 );
					WindowDraw( wp, dbuf, 1 );
					saveope( (void*)vswork, filename, defform );
					closeope( wp, (void*)vswork );
				}else if( info->x >148 && info->x < 187 ){
					closeope( wp, (void*)vswork );
				}
			}
		}else if( info->RightON ){
			if( info->x > 5 && info->x < 43 &&
				 info->y > 3 && info->y < 23 ){
				popupmenu( cwp, info );
			}
		}
		return TRUE;
	case EventMouseEnter:
	case EventMouseOut:
		WindowDraw( wp, dbuf, InputSetCursorVisible( dbuf,
						&input, info->option == EventMouseEnter ) );
		return TRUE;
	case EventUser:
		switch( info->ComData ){
		case UserPaste:
		case UserString:
		case UserStrings:
			return	ClipGetKeyboardAll( wp, info );
		}
		return FALSE;
	}
	return	FALSE;
}

int
inpopen( info )
EventInfo	*info;
{
	if( info->ComData == UserGraphic ){
		if( !gvcopy( (UGraphic*)vswork, info->ComBuffer ) ){
			return FALSE;
		}
		curformat= format;
	}else if( info->ComData == UserSheet ){
		if( !shtcopy( (Sheet*)vswork, info->ComBuffer ) ){
			return FALSE;
		}
		curformat= mformat;
	}else{
		return FALSE;
	}
	defform= 0;
	WindowTitleOpen( 200, 200, 260, 75, NULL, "gv_save", Close, inpexec );
	return TRUE;
}
